
/*
xpequ copyright (c) 2007-always Jan Panteltje

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#include "xpequ.h"
#include "audio.h"

FD_xpequ *fdui;

FL_APPEVENT_CB optimize_idle_cb;

int old_colors_error_mode;


int idle_cb(XEvent *ev, void *data)
{
char temp[80];
static int counter;

if(update_gui_flag)
	{
	update_gui();
	update_gui_flag = 0;	
	
	return 0;
	}

//set_internet_server_name_indicator();
//set_display_filename(input_filename);
	
if(level_enabled_output_flag)
	{
	if(active_state)
		{
		fl_set_object_color(fdui -> level_enabled_output_button, FL_SPRINGGREEN, FL_SPRINGGREEN);
		}
	else
		{
		fl_set_object_color(fdui -> level_enabled_output_button, FL_COL1, FL_YELLOW);
		}
	}
else
	{
	fl_set_object_color(fdui -> level_enabled_output_button, FL_COL1, FL_YELLOW);
	}	

/* decrease processor load */
counter++;
if(counter == 10)
	{
	sprintf(temp, "%d Ch", audio_channels);
	fl_set_object_label(fdui -> channels_indicator, temp);
	if(audio_channels == 1)
		{
		fl_set_object_color(fdui -> channels_indicator, FL_MAGENTA, FL_MAGENTA);
		fl_set_object_lcolor(fdui -> channels_indicator, FL_WHITE);
		}
	else
		{
		fl_set_object_color(fdui -> channels_indicator, FL_BLUE, FL_BLUE);
		fl_set_object_lcolor(fdui -> channels_indicator, FL_WHITE);
		}

	sprintf(temp, "%d", dsp_speed);
	fl_set_object_label(fdui -> sample_speed_indicator, temp);
	fl_set_object_color(fdui -> sample_speed_indicator, FL_BLUE, FL_BLUE);
	fl_set_object_lcolor(fdui ->sample_speed_indicator, FL_WHITE);

	counter = 0;
	}

if(! no_gui_flag)
	{
	if(display_mode == DISPLAY_FFT)
		{
		fl_set_xyplot_data(fdui -> fft_display, fft_x, fft_y, XYPLOT_WIDTH, "", "", "");
		}
	else if(display_mode == DISPLAY_OSCILLOSCOPE)
		{
		fl_set_xyplot_data(fdui -> scope_display, scope_x, scope_y,  XYPLOT_WIDTH, "", "", "");
		}
	}

fl_set_slider_value(fdui -> audio_peak_indicator_slider, audio_peak_level);

if(audio_peak_level > -1.0)
	{
	fl_set_object_color(fdui -> audio_peak_indicator_slider, FL_COL1, FL_RED);
	}
else if(audio_peak_level > -6.0)
	{
	fl_set_object_color(fdui -> audio_peak_indicator_slider, FL_COL1, FL_DARKORANGE);
	}
else if(audio_peak_level > -30.0)
	{
	fl_set_object_color(fdui -> audio_peak_indicator_slider, FL_COL1, FL_GREEN);
	}
else
	{
	fl_set_object_color(fdui -> audio_peak_indicator_slider, FL_COL1, FL_YELLOW);
 	}

if(audio_running_flag)
	{
	fl_set_object_color(fdui -> audio_control_button, FL_GREEN, FL_GREEN);
	}
else
	{
	fl_set_object_color(fdui -> audio_control_button, FL_COL1, FL_COL1);
	}

if(agc_init_flag)
	{
	fl_set_object_color(fdui -> agc_button, FL_COL1, FL_DARKORANGE);	
	}
else
	{
	fl_set_object_color(fdui -> agc_button, FL_COL1, FL_RED);
	}

if(! no_gui_flag)
	{
	if(colors_error_mode != old_colors_error_mode)
		{
		if(colors_error_mode == COLORS_ERROR_DEVICE)
			{
			fl_show_alert("Could not open device", serial_device_name, "for write", 0);
			}
		else if(colors_error_mode == COLORS_ERROR_PORT_PARAMETERS )
			{
			fl_show_alert("Could not set serial port parameters for device", serial_device_name, "baudrate?", 0);
			}

		fl_set_button(fdui -> color_output_button, 0);
		color_output_flag = 0;
		stop_colors();
		save_audio_settings();

		save_setting("serial_device_name", serial_device_name);
		
		old_colors_error_mode = colors_error_mode;
		}
	}

return 0;
} /* end function idle_cb */



