
/*
xpequ copyright (c) 2007-always Jan Panteltje

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#ifndef _WAVE_HEADER_H_
#define _WAVE_HEADER_H_

typedef struct
	{						/* header for WAV-Files */
	uint8_t main_chunk[4];	/* 'RIFF' */
	uint32_t length;		/* length of file */
	uint8_t chunk_type[4];	/* 'WAVE' */
	uint8_t sub_chunk[4];	/* 'fmt' */
	uint32_t length_chunk;	/* length sub_chunk, always 16 bytes */
	uint16_t format;		/* always 1 = PCM-Code */
	uint16_t modus;			/* 1 = Mono, 2 = Stereo */
	uint32_t sample_fq;		/* Sample Freq */
	uint32_t byte_p_sec;	/* Data per sec */
	uint16_t byte_p_spl;	/* bytes per sample, 1=8 bit, 2=16 bit (mono) 2=8 bit, 4=16 bit (stereo) */
	uint16_t bit_p_spl;		/* bits per sample, 8, 12, 16 */
	uint8_t data_chunk[4];	/* 'data' */
	uint32_t data_length;	/* length of data */
	} wave_header;
					
#endif /* _WAVE_HEADER_H_ */

