
/*
xpequ copyright (c) 2007-always Jan Panteltje

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#ifndef _XPVOX_H_
#define _XPVOX_H_

#define USE_FREOPEN
//#define TIMING_CHECKS

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <stdio.h>
#include <unistd.h>
#include <pwd.h>
#include <string.h>
#include "getopt.h"
#include "strings.h"
#include <signal.h>
#include <pthread.h>
#include <fcntl.h>
#include <stdint.h>

#include <sys/types.h>
#include <sys/stat.h>

//#include <linux/soundcard.h>
#include <sys/soundcard.h>

#include <alsa/asoundlib.h>

//#include <sys/time.h>
#include <sys/un.h>
#include <sys/file.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <signal.h>
#include <arpa/inet.h>


#ifdef TIMING_CHECKS
#include <sys/time.h>
#endif // TIMING_CHECKS

#include <sys/ioctl.h>
#include <math.h>
#include <ctype.h>
#include <sys/wait.h>

#include <unistd.h> /* for libc5 */
#include <sys/io.h> /* for glibc */


#include <forms.h>

#include "audio.h"
#include "keys.h"
#include "sounds.h"
#include "wave_header.h"
#include "fft.h"

/* for serial out to col_pic */
#include <termcap.h>
#include <termios.h>


/**** Forms and Objects ****/
typedef struct
	{
	FL_FORM *xpequ;
	void *vdata;
	char *cdata;
	long  ldata;
	FL_OBJECT *equalizer_control0_slider;
	FL_OBJECT *equalizer_control1_slider;
	FL_OBJECT *equalizer_control2_slider;
	FL_OBJECT *equalizer_control3_slider;
	FL_OBJECT *equalizer_control4_slider;
	FL_OBJECT *equalizer_control5_slider;
	FL_OBJECT *equalizer_control6_slider;
	FL_OBJECT *equalizer_control7_slider;
	FL_OBJECT *equalizer_control8_slider;
	FL_OBJECT *equalizer_control9_slider;
	FL_OBJECT *fft_display;
	FL_OBJECT *scope_display;
	FL_OBJECT *fft_log_x_axis_group;
	FL_OBJECT *non_equalizer_group;
//	FL_OBJECT *fft_log_x_axis_2_text;
	FL_OBJECT *fft_log_x_axis_22_text;
	FL_OBJECT *fft_log_x_axis_220_text;
	FL_OBJECT *fft_log_x_axis_2200_text;
	FL_OBJECT *fft_log_x_axis_22k_text;
	FL_OBJECT *main_form_text;
	FL_OBJECT *equalizer_display;
	FL_OBJECT *audio_peak_indicator_slider;
	FL_OBJECT *channels_indicator;
	FL_OBJECT *sample_speed_indicator;
	FL_OBJECT *threshold_slider;
	FL_OBJECT *on_time_slider;
	FL_OBJECT *off_time_slider;
	FL_OBJECT *equalizer_enable_button;
	FL_OBJECT *audio_mode_select_button;
	FL_OBJECT *agc_button;
	FL_OBJECT *level_enabled_output_button;
	FL_OBJECT *color_output_button;
	FL_OBJECT *serial_device_select_button;
	FL_OBJECT *off_time_x10_button;
	FL_OBJECT *remote_indicator;
	FL_OBJECT *internet_stream_button;
	FL_OBJECT *internet_server_name_indicator;
	FL_OBJECT *filename_indicator;
	FL_OBJECT *equalizer_gain_slider;
	FL_OBJECT *display_mode_button;
	FL_OBJECT *fft_log_scale_button;
	FL_OBJECT *scope_speed_up_button;
	FL_OBJECT *scope_speed_text;
	FL_OBJECT *scope_speed_down_button;
	FL_OBJECT *scope_trigger_mode_button;
	FL_OBJECT *scope_trigger_level_slider;
	FL_OBJECT *scope_timebase_text;
	FL_OBJECT *scope_auto_trigger_button;
	FL_OBJECT *scope_sensitivity_up_button;
	FL_OBJECT *scope_sensitivity_text;
	FL_OBJECT *scope_sensitivity_down_button;
	FL_OBJECT *scope_sensitivity_label_text;
	FL_OBJECT *audio_input_device_select_button;
	FL_OBJECT *audio_input_text;
	FL_OBJECT *audio_output_device_select_button;
	FL_OBJECT *audio_output_text;
	FL_OBJECT *audio_control_button;
	FL_OBJECT *exit_button;
	} FD_xpequ;

extern FD_xpequ * create_form_xpequ(void);

/* for position browser display */
#define SHOW_TOP			0
#define SHOW_SAME_POSITION	1
#define SHOW_UNREAD_AT_TOP	2
#define SHOW_BOTTOM			3
#define SHOW_SELECTED		4

/* for audio devices */
#define AUDIO_DEVICE_FIRST	0
#define AUDIO_DEVICE_LAST	3

#define AUDIO_SUB_DEVICE_FIRST	0
#define AUDIO_SUB_DEVICE_LAST	3

int debug_flag;
struct passwd *userinfo;
char *user_name;
char *home_dir;
double threshold;
char *audio_input_device_name;
char *audio_output_device_name;
int output_flag;
int high_samples;
int low_samples;
double on_milli_seconds;
double off_milli_seconds;
double milli_seconds_per_sample;
double audio_peak_level;
double audio_current_level;
double minimum_db;
int set_mixer_flag;
int audio_input_device_number;
int audio_input_device_sub_number;
int audio_output_device_number;
int audio_output_device_sub_number;
int old_audio_input_device_number;
int old_audio_input_device_sub_number;
int old_audio_output_device_number;
int old_audio_output_device_sub_number;
int alarm_hour, alarm_minute;
char weekday[20];
char month[20];
int monthday, hour, minute, second, year;
int off_time_10x_flag;
int equalizer_enable_flag;
float *fft_x, *fft_y;
float *scope_x, *scope_y;
float *scope_measure_x, *scope_measure_y;
double equalizer_gain;
int display_mode;
int active_state;
int level_enabled_output_flag;
int audio_channels;
int fft_log_scale_flag;
int equalizer_slider_value[10];
char *equalizer_filename;
int use_input_file_flag;
char *input_filename;
char *output_filename;
int32_t input_filelength;
int32_t input_datalength;
int raw_output_flag;
int no_gui_flag;
int show_progres_flag;
struct stat *statptr;
time_t modification_time_s;
unsigned long int modification_time_us;
int header_size;
wave_header *in_header;
int audio_mode;
int command_line_input_device_specified_flag;
int command_line_output_device_specified_flag;
int scope_time_per_division_multiplier;
double scope_trigger_level;
int scope_trigger_mode;
int scope_auto_trigger_flag;
int scope_sensitivity;
int agc_flag;
int agc_init_flag;
double agc_level;
double agc_multiplier;
int audio_running_flag;
fft_t *fft;
int input_stream_flag;
int internet_mode;
int internet_running_flag;
char *internet_server_name;
int internet_port;
int internet_socket_fd;
int update_gui_flag;
int internet_client_sock;
int internet_connected_flag;
int internet_clients;
int internet_stream_flag;
int internet_stream_client_exit_flag;
int new_audio_flag;
char *inbuffer;
int remote_audio_input_device_number;
int remote_audio_output_device_number;
int remote_audio_mode;
int remote_audio_input_device_sub_number;
int remote_audio_output_device_sub_number;
int remote_command_line_input_device_specified_flag;
int remote_command_line_output_device_specified_flag;
int remote_output_flag;
int remote_use_input_file_flag;
int colors_running_flag;
int colors_error_mode;

/* for output to col_pic */
int color_output_flag;
char *serial_device_name;
int baudrate;

int average_red;
int average_green;
int average_blue;

double avrg_red;
double avrg_green;
double avrg_blue;

int times_here_red;
int times_here_green;
int times_here_blue;


#ifdef TIMING_CHECKS
struct timeval *start_timeval;
struct timeval *current_timeval;
#endif // TIMING_CHECKS

#define DEFAULT_AUDIO_INPUT_DEVICE_NUMBER	0
#define DEFAULT_AUDIO_OUTPUT_DEVICE_NUMBER	1
#define DEFAULT_THRESHOLD					-33.0
#define DEFAULT_DSP_SPEED					44100
#define DEFAULT_ON_TIME						1.5
#define DEFAULT_OFF_TIME					1500.0

/* xy plot related */
#define XYPLOT_WIDTH			512
#define XYPLOT_HEIGHT			256

/* fft display related */
#define FPS                      20
#define FFT_BITS                 11
#define NUMSAMPLES				(1 << FFT_BITS)

/* equalizer */
#define EQUALIZER_RANGE		14
#define EQ_BANDS            10

/* input and output device selection */
#define USE_ALSA			0
#define USE_OSS				1

/* for display mode */
#define DISPLAY_NONE			0
#define DISPLAY_FFT				1
#define DISPLAY_OSCILLOSCOPE	2

/* for scope trigger mode */
#define SCOPE_TRIGGER_MODE_POS_EDGE				0
#define SCOPE_TRIGGER_MODE_NEG_EDGE				1

/* scope timebase */
#define SCOPE_MIN_TIME_PER_DIVISION_MULTIPLIER	1
#define SCOPE_MAX_TIME_PER_DIVISION_MULTIPLIER	50

/* scope sensitivity */
#define SCOPE_MIN_SENSITIVITY					1
#define SCOPE_MAX_SENSITIVITY					100

/* AGC */
#define AGC_MAX_GAIN							50
#define AGC_INIT_GAIN_INCREASE_SPEED			.0001
#define AGC_GAIN_INCREASE_SPEED					.000001

/* VU meter */
#define VU_METER_DROP_BACK_SPEED				.001

/* for audio */
#define AUDIO_BUFFER_SIZE						8192
#define AUDIO_HEADER_SIZE						44

/* for internet */
#define MAX_LISTEN_QUEUE 						1
/* must be the same as AUDIO_BUFFER_SIZE!!!! for streaming */
#define INTERNET_BUFFER_SIZE					8192

/* for strings */
#define READSIZE								4096

/* internet mode */
#define INTERNET_OFF							0
#define INTERNET_SERVER							1
#define INTERNET_CLIENT							2

#define FILENAME_DISPLAY_SIZE					125

/* for color out */
#define DEFAULT_SERIAL_DEVICE_NAME				"/dev/ttyUSB0"
#define DEFAULT_BAUDRATE						19200

/* for colors error report */
#define COLORS_ERROR_NONE						0
#define	COLORS_ERROR_DEVICE						1
#define COLORS_ERROR_PORT_PARAMETERS			2

#define PROG_VERSION "xpequ-0.3.5"

#include "xpequ_proto.h"

#endif /* _XPVOX_H_ */

