
/*
xpvox copyright (c) 2007-always Jan Panteltje

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef _XPVOX_PROTO_H_
#define _XPVOX_PROTO_H_

extern int send_audio_buffer(int socket);
extern void internet_stream_button_cb(FL_OBJECT *ob, long data);
extern int set_internet_server_name_indicator();
extern int set_display_filename(char *filename);
extern int ask_client_to_disconnect(int socket);
extern int send_remote_command();
extern int update_gui();
extern int read_status(char *buffer);
extern int send_status(int port);
extern int init_sockaddr(struct sockaddr_in *name, const char *hostname, unsigned short int port);
extern int start_internet();
extern int stop_internet();
extern void *internet_routine();
extern int make_socket(unsigned short int port);
extern int rewrite_wave_header();
extern void audio_control_button_cb(FL_OBJECT *ob, long data);
extern void agc_button_cb(FL_OBJECT *ob, long data);
extern int set_equalizer_objects(int state);
extern void scope_sensitivity_up_button_cb(FL_OBJECT *ob, long data);
extern void scope_sensitivity_down_button_cb(FL_OBJECT *ob, long data);
extern void scope_auto_trigger_button_cb(FL_OBJECT *ob, long data);
extern void scope_speed_up_button_cb(FL_OBJECT *ob, long data);
extern void scope_speed_down_button_cb(FL_OBJECT *ob, long data);
extern void scope_trigger_mode_button_cb(FL_OBJECT *ob, long data);
extern void scope_trigger_level_slider_cb(FL_OBJECT *ob, long data);
extern int set_display_mode_button_label(int mode);
extern int set_io_buttons(int flag);
extern void audio_mode_select_button_cb(FL_OBJECT *ob, long data);
extern int input_init();
extern int output_init();
extern int save_equalizer(char *pathfilename);
extern int load_equalizer(char *pathfilename);
extern void fft_log_scale_button_cb(FL_OBJECT *ob, long data);
extern void level_enabled_output_button_cb(FL_OBJECT *ob, long data);
extern void display_mode_button_cb(FL_OBJECT *ob, long data);
extern void equalizer_gain_slider_cb(FL_OBJECT *ob, long data);
extern int equalizer_init();
extern int equalize(int16_t *data, int channels, int frames);
extern int get_equalizer(int property, int *value);
extern int set_equalizer(int property, int value);
extern void equalizer_control0_slider_cb(FL_OBJECT *ob, long data);
extern void equalizer_control1_slider_cb(FL_OBJECT *ob, long data);
extern void equalizer_control2_slider_cb(FL_OBJECT *ob, long data);
extern void equalizer_control3_slider_cb(FL_OBJECT *ob, long data);
extern void equalizer_control4_slider_cb(FL_OBJECT *ob, long data);
extern void equalizer_control5_slider_cb(FL_OBJECT *ob, long data);
extern void equalizer_control6_slider_cb(FL_OBJECT *ob, long data);
extern void equalizer_control7_slider_cb(FL_OBJECT *ob, long data);
extern void equalizer_control8_slider_cb(FL_OBJECT *ob, long data);
extern void equalizer_control9_slider_cb(FL_OBJECT *ob, long data);
extern void fft_display_cb(FL_OBJECT *ob, long data);
extern void scope_display_cb(FL_OBJECT *ob, long data);
extern void set_off_slider_bounds();
extern void equalizer_display_cb(FL_OBJECT *ob, long data);
extern void equalizer_enable_button_cb(FL_OBJECT *ob, long data);
extern void off_time_x10_button_cb(FL_OBJECT *ob, long data);
extern void one_second_tick(int sig);
extern int ogettime(
	char *weekday,
	char *month, 
	int *monthday,
	int *hour,  
	int *minute,  
	int *second,  
	int *year   
	);
extern int get_sound(int mode, int *sound);
extern int start_audio();
extern int stop_audio();
extern int save_audio_settings();
extern int load_audio_settings();
extern int set_audio_input_device_name(int nr, int subnr);
extern int set_audio_output_device_name(int nr, int subnr);
extern void audio_input_device_select_button_cb(FL_OBJECT *ob, long data);
extern void audio_output_device_select_button_cb(FL_OBJECT *ob, long data);
extern void replace(char *text, char *string, char *replace, char *result);
extern int readline(FILE *file, char *contents);
extern char *load_setting(char *type);
extern int save_setting(char *type, char *string);
extern void audio_peak_indicator_slider_cb(FL_OBJECT *ob, long data);
extern void on_time_slider_cb(FL_OBJECT *ob, long data);
extern void off_time_slider_cb(FL_OBJECT *ob, long data);
extern void *audio_routine();
extern int print_usage();
extern int idle_cb(XEvent *ev, void *data);
extern void one_second_tick(int sig);
extern void threshold_slider_cb(FL_OBJECT *ob, long data);
extern void exit_button_cb(FL_OBJECT *ob, long data);
extern char *strsave(char *s);
extern int set_port_parameters(int fd, int baudrate, char *device);
extern void *colors_routine();
extern int stop_colors();
extern int start_colors();
extern void color_output_button_cb(FL_OBJECT *ob, long data);
extern void serial_device_select_button_cb(FL_OBJECT *ob, long data);


#endif /* _XPVOX_PROTO_H_ */

